Index: src/sas/sasgui/perspectives/calculator/calculator.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/calculator.py	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ src/sas/sasgui/perspectives/calculator/calculator.py	(revision a0c1e1de9eb99665b31c85c4fddcfca740db719c)
@@ -80,5 +80,5 @@
                 ("Kiessig Thickness Calculator",
                         kiessig_help, self.on_calculate_kiessig),
-                          ("SAS Resolution Estimator",
+                          ("Q Resolution Estimator",
                         resolution_help, self.on_calculate_resoltuion),
                 ("Generic Scattering Calculator",
Index: src/sas/sasgui/perspectives/calculator/data_operator.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/data_operator.py	(revision 0e760e9190d1a156409589ee9c50372130d80dbe)
+++ src/sas/sasgui/perspectives/calculator/data_operator.py	(revision 61780e3355265f8377c4d588db7b820d2c9989a7)
@@ -397,5 +397,5 @@
             self._set_textctrl_color(self.data1_cbox, 'pink')
             self._set_textctrl_color(self.data2_cbox, 'pink')
-            msg = "DataOperation: Data types must be same."
+            msg = "DataOperation: %s" % sys.exc_value
             self.send_warnings(msg, 'error')
             self.output = None
Index: src/sas/sasgui/perspectives/calculator/pyconsole.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/pyconsole.py	(revision f1cbae76f663f0b5d581265b20a168fdcaca6f90)
+++ src/sas/sasgui/perspectives/calculator/pyconsole.py	(revision 0912b405bd0067ba7456b60f02342b50c7f6671b)
@@ -231,4 +231,11 @@
         if result.path:
             self.bufferCreate(result.path)
+
+        # See if there is a corresponding C file
+        if result.path != None:
+            c_filename = os.path.splitext(result.path)[0] + ".c"
+            if os.path.isfile(c_filename):
+                self.bufferCreate(c_filename)
+
         cancel = False
         return cancel
Index: src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py	(revision d0248bd59e16e863c884f4be9af0a03b2a86b6e2)
+++ src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py	(revision a0c1e1de9eb99665b31c85c4fddcfca740db719c)
@@ -63,5 +63,5 @@
     """
     ## Internal nickname for the window, used by the AUI manager
-    window_name = "SAS Resolution Estimator"
+    window_name = "Q Resolution Estimator"
     ## Name to appear on the window title bar
     window_caption = ""
@@ -1329,5 +1329,5 @@
     """
     def __init__(self, parent=None, manager=None,
-                 title="SAS Resolution Estimator",
+                 title="Q Resolution Estimator",
                  size=(PANEL_WIDTH * 2, PANEL_HEIGHT), *args, **kwds):
         kwds['title'] = title
Index: src/sas/sasgui/perspectives/file_converter/converter_panel.py
===================================================================
--- src/sas/sasgui/perspectives/file_converter/converter_panel.py	(revision be880765648278fd07d2d8b28d75b9ca7b238527)
+++ src/sas/sasgui/perspectives/file_converter/converter_panel.py	(revision ed9f87285808f62d344f2b0a8c086bbce09ab338)
@@ -499,10 +499,13 @@
         vbox = wx.BoxSizer(wx.VERTICAL)
 
-        instructions = ("Select either single column ASCII files or 1D OTOKO "
-        "files containing the Q-Axis and Intensity-Axis data, or a 2D BSL file"
-        ", then chose where to save the converted file, and click Convert.\n"
-        "ASCII and OTOKO files can be converted to CanSAS XML, or NXcanSAS "
-        "HDF5 format. OTOKO files can only be converted to NXcanSAS.\nCanSAS "
-        "metadata can also be optionally input below.")
+        instructions = (
+        "Select linked single column 1D ASCII files containing the Q-axis and "
+        "Intensity-axis data, or 1D BSL/OTOKO files, or a 2D BSL/OTOKO file, "
+        "then choose where to save the converted file, and click Convert.\n"
+        "1D ASCII and BSL/OTOKO files can be converted to CanSAS (XML) or "
+        "NXcanSAS (HDF5) formats. 2D BSL/OTOKO files can only be converted to "
+        "the NXcanSAS format.\n"
+        "Metadata can be optionally added for the CanSAS XML format."
+        )
 
         instruction_label = wx.StaticText(self, -1, instructions,
@@ -527,5 +530,5 @@
         ascii_btn.Bind(wx.EVT_RADIOBUTTON, self.datatype_changed)
         radio_sizer.Add(ascii_btn)
-        otoko_btn = wx.RadioButton(self, -1, "OTOKO 1D", name="otoko")
+        otoko_btn = wx.RadioButton(self, -1, "BSL 1D", name="otoko")
         otoko_btn.Bind(wx.EVT_RADIOBUTTON, self.datatype_changed)
         radio_sizer.Add(otoko_btn)
Index: src/sas/sasgui/perspectives/fitting/basepage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/basepage.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
+++ src/sas/sasgui/perspectives/fitting/basepage.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
@@ -9,5 +9,4 @@
 import copy
 import math
-import string
 import json
 import logging
@@ -340,11 +339,4 @@
         self.data.detector[index].beam_center.x = qmax
         self.data.detector[index].beam_center.y = qmax
-        ## create x_bins and y_bins of the model 2D
-        #pixel_width_x = self.data.detector[index].pixel_size.x
-        #pixel_width_y = self.data.detector[index].pixel_size.y
-        #center_x = self.data.detector[index].beam_center.x/pixel_width_x
-        #center_y = self.data.detector[index].beam_center.y/pixel_width_y
-        # theory default: assume the beam
-        #center is located at the center of sqr detector
         xmax = qmax
         xmin = -qmax
@@ -365,14 +357,7 @@
         # set all True (standing for unmasked) as default
         mask = numpy.ones(len(qx_data), dtype=bool)
-        # calculate the range of qx and qy: this way,
-        # it is a little more independent
-        #x_size = xmax - xmin
-        #y_size = ymax - ymin
         # store x and y bin centers in q space
         x_bins = x
         y_bins = y
-        # bin size: x- & y-directions
-        #xstep = x_size / len(x_bins - 1)
-        #ystep = y_size / len(y_bins - 1)
 
         self.data.source = Source()
@@ -415,43 +400,10 @@
             batch_menu.Enable(self.batch_on and flag)
 
-    def set_page_info(self, page_info):
-        """
-        set some page important information at once
-        """
-#       THIS METHOD/FUNCTION NO LONGE APPEARS TO BE CALLED.  Started up program
-#       and started new fit window and PR and Invariant and a fit in fitting
-#       but never entered this routine which should be an initialization
-#       routine.  Leave for a while but probably something to clean up at
-#       some point?
-#
-#       PDB April 13 2014
-#
-        ##window_name
-        self.window_name = page_info.window_name
-        ##window_caption
-        self.window_caption = page_info.window_caption
-        ## manager is the fitting plugin
-        self._manager = page_info.manager
-        ## owner of the page (fitting plugin)
-        self.event_owner = page_info.event_owner
-        ## current model
-        self.model = page_info.model
-        ## data
-        self.data = page_info.data
-        ## dictionary containing list of models
-        self.model_list_box = page_info.model_list_box
-        ## Data member to store the dispersion object created
-        self.populate_box(model_dict=self.model_list_box)
-
     def onContextMenu(self, event):
         """
         Retrieve the state selected state
         """
-        # Skipping the save state functionality for release 0.9.0
-        #return
-
         pos = event.GetPosition()
         pos = self.ScreenToClient(pos)
-
         self.PopupMenu(self.popUpMenu, pos)
 
@@ -570,28 +522,7 @@
     def initialize_combox(self):
         """
-        put default value in the combobox
-        """
-        ## fill combox box
-        if self.model_list_box is None:
-            return
-        if len(self.model_list_box) > 0:
-        ## This is obsolete code since form factor box is no longer static.
-        ## It is now set dynamically through _show_combox and _show_combos_helper
-        ## These are called for first time by formfactor_combo_init
-        ## itself called from fitpanel only.  If we find that I'm wrong and
-        ## we DO need to initialize somehow here - do it by a call to
-        ## formfactor_combo_init
-        ## self.formfator_combo_init()
-        ## BUT NOT HERE -- make it last line of this
-        ## method so that structure box is populated before _show_comboox_helper
-        ## is called.  Otherwise wx will complain mightily:-)
-        ##
-        ## Also change the name to initiatlize_structurebox along with changes
-        ## to other combobox methods (_populate_listbox --> _populate_categorybox
-        ## etc )
-        ##
-        ##     PDB 4/26/2014
-#            self._populate_box(self.formfactorbox,
-#                               self.model_list_box["Shapes"])
+        put default value in the combo box
+        """
+        if self.model_list_box is not None and len(self.model_list_box) > 0:
             self._populate_box(self.structurebox,
                                self.model_list_box["Structure Factors"])
@@ -602,11 +533,4 @@
             self.structurebox.Disable()
             self.text2.Disable()
-
-            if self.model.__class__ in self.model_list_box["P(Q)*S(Q)"]:
-                self.structurebox.Show()
-                self.text2.Show()
-                self.structurebox.Enable()
-                self.text2.Enable()
-
 
     def set_dispers_sizer(self):
@@ -746,5 +670,4 @@
         else:
             wx.CallAfter(self.get_copy)
-
 
     def on_paste(self, event):
@@ -960,9 +883,9 @@
                                      self.state.orientation_params)
         self._copy_parameters_state(self.orientation_params_disp,
-                                     self.state.orientation_params_disp)
+                                    self.state.orientation_params_disp)
 
         self._copy_parameters_state(self.parameters, self.state.parameters)
         self._copy_parameters_state(self.fittable_param,
-                                     self.state.fittable_param)
+                                    self.state.fittable_param)
         self._copy_parameters_state(self.fixed_param, self.state.fixed_param)
         #save chisqr
@@ -1052,10 +975,4 @@
         self.disp_cb_dict = state.disp_cb_dict
         self.disp_list = state.disp_list
-
-        ## set the state of the radio box
-        #self.shape_rbutton.SetValue(state.shape_rbutton)
-        #self.shape_indep_rbutton.SetValue(state.shape_indep_rbutton)
-        #self.struct_rbutton.SetValue(state.struct_rbutton)
-        #self.plugin_rbutton.SetValue(state.plugin_rbutton)
 
         ## fill model combobox
@@ -1886,6 +1803,5 @@
             if mod_cat == custom_model:
                 for model in self.model_list_box[mod_cat]:
-                    str_m = model.id if hasattr(model, 'id') else model.name
-                    m_list.append(self.model_dict[str_m])
+                    m_list.append(self.model_dict[model.name])
             else:
                 cat_dic = self.master_category_dict[mod_cat]
@@ -1893,8 +1809,4 @@
                     if enabled:
                         m_list.append(self.model_dict[model])
-                    #else:
-                    #    msg = "This model is disabled by Category Manager."
-                    #    wx.PostEvent(self.parent.parent,
-                    #                 StatusEvent(status=msg, info="error"))
         except Exception:
             msg = traceback.format_exc()
@@ -2067,5 +1979,5 @@
             form_factor = self.formfactorbox.GetClientData(f_id)
 
-        if not form_factor in  self.model_list_box["multiplication"]:
+        if form_factor is None or not form_factor.is_form_factor:
             self.structurebox.Hide()
             self.text2.Hide()
@@ -3474,18 +3386,8 @@
         self.by_model_dict = defaultdict(list)
         self.model_enabled_dict = defaultdict(bool)
-
-        try:
-            categorization_file = CategoryInstaller.get_user_file()
-            if not os.path.isfile(categorization_file):
-                categorization_file = CategoryInstaller.get_default_file()
-            cat_file = open(categorization_file, 'rb')
-            self.master_category_dict = json.load(cat_file)
-            self._regenerate_model_dict()
-            cat_file.close()
-        except IOError:
-            raise
-            print 'Problem reading in category file.'
-            print 'We even looked for it, made sure it was there.'
-            print 'An existential crisis if there ever was one.'
+        categorization_file = CategoryInstaller.get_user_file()
+        with open(categorization_file, 'rb') as f:
+            self.master_category_dict = json.load(f)
+        self._regenerate_model_dict()
 
     def _regenerate_model_dict(self):
Index: src/sas/sasgui/perspectives/fitting/fitpanel.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitpanel.py	(revision 05228b001b88187176fb9a2d1bfd9098273fb854)
+++ src/sas/sasgui/perspectives/fitting/fitpanel.py	(revision e6de6b8b31744ebe652ab6206d60d0d20979c592)
@@ -10,7 +10,7 @@
 
 from sas.sasgui.guiframe.panel_base import PanelBase
-from sas.sasgui.guiframe.events import PanelOnFocusEvent
-from sas.sasgui.guiframe.events import StatusEvent
+from sas.sasgui.guiframe.events import PanelOnFocusEvent, StatusEvent
 from sas.sasgui.guiframe.dataFitting import check_data_validity
+from sas.sasgui.perspectives.fitting.simfitpage import SimultaneousFitPage
 
 import basepage
@@ -18,4 +18,5 @@
 _BOX_WIDTH = 80
 
+
 class FitPanel(nb, PanelBase):
     """
@@ -26,7 +27,7 @@
 
     """
-    ## Internal name for the AUI manager
+    # Internal name for the AUI manager
     window_name = "Fit panel"
-    ## Title to appear on top of the window
+    # Title to appear on top of the window
     window_caption = "Fit Panel "
     CENTER_PANE = True
@@ -40,28 +41,28 @@
                     wx.CLIP_CHILDREN)
         PanelBase.__init__(self, parent)
-        #self.SetWindowStyleFlag(style=nb.FNB_FANCY_TABS)
+        # self.SetWindowStyleFlag(style=nb.FNB_FANCY_TABS)
         self._manager = manager
         self.parent = parent
         self.event_owner = None
-        #dictionary of miodel {model class name, model class}
+        # dictionary of miodel {model class name, model class}
         self.menu_mng = models.ModelManager()
         self.model_list_box = self.menu_mng.get_model_list()
-        #pageClosedEvent = nb.EVT_FLATNOTEBOOK_PAGE_CLOSING
+        # pageClosedEvent = nb.EVT_FLATNOTEBOOK_PAGE_CLOSING
         self.model_dictionary = self.menu_mng.get_model_dictionary()
         self.pageClosedEvent = wx.aui.EVT_AUINOTEBOOK_PAGE_CLOSE
 
         self.Bind(self.pageClosedEvent, self.on_close_page)
-        ## save the title of the last page tab added
+        # save the title of the last page tab added
         self.fit_page_name = {}
-        ## list of existing fit page
+        # list of existing fit page
         self.opened_pages = {}
-        #index of fit page
+        # index of fit page
         self.fit_page_index = 0
-        #index of batch page
+        # index of batch page
         self.batch_page_index = 0
-        #page of simultaneous fit
+        # page of simultaneous fit
         self.sim_page = None
         self.batch_page = None
-        ## get the state of a page
+        # get the state of a page
         self.Bind(basepage.EVT_PAGE_INFO, self._onGetstate)
         self.Bind(basepage.EVT_PREVIOUS_STATE, self._onUndo)
@@ -80,30 +81,25 @@
         """
         return an xml node containing state of the panel
-         that guiframe can write to file
-        """
-        msg = ""
+        that guiframe can write to file
+        """
+        # Iterate through all pages and check for batch fitting
+        batch_state = None
+        if self.sim_page is not None:
+            batch_state = self.sim_page.set_state()
+
         for uid, page in self.opened_pages.iteritems():
-            if page.batch_on:
-                pos = self.GetPageIndex(page)
-                if pos != -1 and page not in [self.sim_page, self.batch_page]:
-                    msg += "%s .\n" % str(self.GetPageText(pos))
-            else:
-                data = page.get_data()
-                # state must be cloned
-                state = page.get_state().clone()
-                if data is not None and page.model is not None:
-                    new_doc = self._manager.state_reader.write_toXML(data,
-                                                                     state)
-                    if doc != None and hasattr(doc, "firstChild"):
-                        child = new_doc.firstChild.firstChild
-                        doc.firstChild.appendChild(child)
-                    else:
-                        doc = new_doc
-        if msg.strip() != "":
-            temp = "Save Project is not supported for Batch page.\n"
-            temp += "The following pages will not be save:\n"
-            message = temp + msg
-            wx.PostEvent(self._manager.parent, StatusEvent(status=message,
-                                                            info="warning"))
+            data = page.get_data()
+            # state must be cloned
+            state = page.get_state().clone()
+            if data is not None or page.model is not None:
+                new_doc = self._manager.state_reader.write_toXML(data,
+                                                                 state,
+                                                                 batch_state)
+                if doc is not None and hasattr(doc, "firstChild"):
+                    child = new_doc.firstChild.firstChild
+                    doc.firstChild.appendChild(child)
+                else:
+                    doc = new_doc
+
         return doc
 
@@ -179,5 +175,5 @@
     def get_state(self):
         """
-         return the state of the current selected page
+        return the state of the current selected page
         """
         pos = self.GetSelection()
@@ -191,9 +187,9 @@
         """
 
-        #get number of pages
+        # get number of pages
         nop = self.GetPageCount()
-        #use while-loop, for-loop will not do the job well.
+        # use while-loop, for-loop will not do the job well.
         while (nop > 0):
-            #delete the first page until no page exists
+            # delete the first page until no page exists
             page = self.GetPage(0)
             if self._manager.parent.panel_on_focus == page:
@@ -201,10 +197,11 @@
             self._close_helper(selected_page=page)
             self.DeletePage(0)
-            nop = nop - 1
-
-        ## save the title of the last page tab added
+            nop = self.GetPageCount()
+        # Clear list of names
         self.fit_page_name = {}
-        ## list of existing fit page
+        # Clear list of opened pages
         self.opened_pages = {}
+        self.fit_page_index = 0
+        self.batch_page_index = 0
 
     def set_state(self, state):
@@ -215,5 +212,5 @@
         if state is not None:
             for uid, panel in self.opened_pages.iteritems():
-                #Don't return any panel is the exact same page is created
+                # Don't return any panel is the exact same page is created
                 if uid == panel.uid and panel.data == state.data:
                     # the page is still opened
@@ -223,8 +220,8 @@
             if not page_is_opened:
                 if state.data.__class__.__name__ != 'list':
-                    #To support older state file format
+                    # To support older state file format
                     list_data = [state.data]
                 else:
-                    #Todo: need new file format for the list
+                    # Todo: need new file format for the list
                     list_data = state.data
                 panel = self._manager.add_fit_page(data=list_data)
@@ -241,8 +238,9 @@
         Clear and close all panels, used by guimanager
         """
-
-        #close all panels only when svs file opened
+        # close all panels only when svs file opened
         self.close_all()
         self._manager.mypanels = []
+        self.sim_page = None
+        self.batch_page = None
 
     def on_close_page(self, event=None):
@@ -253,5 +251,5 @@
         selected_page = self.GetPage(self.GetSelection())
         if nbr_page == 1:
-            if selected_page.get_data() == None:
+            if selected_page.get_data() is not None:
                 if event is not None:
                     event.Veto()
@@ -271,6 +269,6 @@
 
                 if data is None:
-                    #the fitpanel exists and only the initial fit page is open
-                    #with no selected data
+                    # the fitpanel exists and only the initial fit page is open
+                    # with no selected data
                     return
                 if data.id == deleted_data.id:
@@ -284,5 +282,4 @@
 
         :param manager: instance of plugin fitting
-
         """
         self._manager = manager
@@ -333,5 +330,5 @@
         else:
             self.batch_page = SimultaneousFitPage(self, batch_on=True,
-                                                   page_finder=page_finder)
+                                                  page_finder=page_finder)
             self.batch_page.window_caption = caption
             self.batch_page.window_name = caption
@@ -346,16 +343,6 @@
         add an empty page
         """
-        """
         if self.batch_on:
             from batchfitpage import BatchFitPage
-            panel = BatchFitPage(parent=self)
-            #Increment index of batch page
-            self.batch_page_index += 1
-            index = self.batch_page_index
-        else:
-        """
-        from fitpage import FitPage
-        from batchfitpage import BatchFitPage
-        if self.batch_on:
             panel = BatchFitPage(parent=self)
             self.batch_page_index += 1
@@ -363,5 +350,6 @@
             panel.set_index_model(self.batch_page_index)
         else:
-            #Increment index of fit page
+            # Increment index of fit page
+            from fitpage import FitPage
             panel = FitPage(parent=self)
             self.fit_page_index += 1
@@ -441,9 +429,9 @@
         page = None
         for p in self.opened_pages.values():
-            #check if there is an empty page to fill up
+            # check if there is an empty page to fill up
             if not check_data_validity(p.get_data()) and p.batch_on:
 
-                #make sure data get placed in 1D empty tab if data is 1D
-                #else data get place on 2D tab empty tab
+                # make sure data get placed in 1D empty tab if data is 1D
+                # else data get place on 2D tab empty tab
                 enable2D = p.get_view_mode()
                 if (data.__class__.__name__ == "Data2D" and enable2D)\
@@ -458,13 +446,13 @@
                 data_type = dlg.get_data()
                 dlg.Destroy()
-                if page  is None:
+                if page is None:
                     page = self.add_empty_page()
                 if data_type == 1:
-                    #user has selected only data1D
+                    # user has selected only data1D
                     page.fill_data_combobox(data_1d_list)
                 elif data_type == 2:
                     page.fill_data_combobox(data_2d_list)
             else:
-                #the batch analysis is canceled
+                # the batch analysis is canceled
                 dlg.Destroy()
                 return None
@@ -503,5 +491,5 @@
             try:
                 data = data_list[0]
-            except:
+            except Exception:
                 # for 'fitv' files
                 data_list = [data]
@@ -511,20 +499,20 @@
                 return None
         for page in self.opened_pages.values():
-            #check if the selected data existing in the fitpanel
+            # check if the selected data existing in the fitpanel
             pos = self.GetPageIndex(page)
             if not check_data_validity(page.get_data()) and not page.batch_on:
-                #make sure data get placed in 1D empty tab if data is 1D
-                #else data get place on 2D tab empty tab
+                # make sure data get placed in 1D empty tab if data is 1D
+                # else data get place on 2D tab empty tab
                 enable2D = page.get_view_mode()
                 if (data.__class__.__name__ == "Data2D" and enable2D)\
-                or (data.__class__.__name__ == "Data1D" and not enable2D):
+                   or (data.__class__.__name__ == "Data1D" and not enable2D):
                     page.batch_on = self.batch_on
                     page._set_save_flag(not page.batch_on)
                     page.fill_data_combobox(data_list)
-                    #caption = "FitPage" + str(self.fit_page_index)
+                    # caption = "FitPage" + str(self.fit_page_index)
                     self.SetPageText(pos, page.window_caption)
                     self.SetSelection(pos)
                     return page
-        #create new page and add data
+        # create new page and add data
         page = self.add_empty_page()
         pos = self.GetPageIndex(page)
@@ -574,8 +562,8 @@
         Delete the given page from the notebook
         """
-        #remove hint page
-        #if selected_page == self.hint_page:
+        # remove hint page
+        # if selected_page == self.hint_page:
         #    return
-        ## removing sim_page
+        # removing sim_page
         if selected_page == self.sim_page:
             self._manager.sim_page = None
@@ -584,25 +572,17 @@
             self._manager.batch_page = None
             return
-        """
-        # The below is not working when delete #5 and still have #6.
-        if selected_page.__class__.__name__ == "FitPage":
-            self.fit_page_index -= 1
-        else:
-            self.batch_page_index -= 1
-        """
-        ## closing other pages
+        # closing other pages
         state = selected_page.createMemento()
         page_finder = self._manager.get_page_finder()
-        ## removing fit page
+        # removing fit page
         data = selected_page.get_data()
-        #Don' t remove plot for 2D
+        # Don' t remove plot for 2D
         flag = True
         if data.__class__.__name__ == 'Data2D':
             flag = False
         if selected_page in page_finder:
-            #Delete the name of the page into the list of open page
+            # Delete the name of the page into the list of open page
             for uid, list in self.opened_pages.iteritems():
-                #Don't return any panel is the exact same page is created
-
+                # Don't return any panel is the exact same page is created
                 if flag and selected_page.uid == uid:
                     self._manager.remove_plot(uid, theory=False)
@@ -610,21 +590,21 @@
             del page_finder[selected_page]
 
-        #Delete the name of the page into the list of open page
+        # Delete the name of the page into the list of open page
         for uid, list in self.opened_pages.iteritems():
-            #Don't return any panel is the exact same page is created
+            # Don't return any panel is the exact same page is created
             if selected_page.uid == uid:
                 del self.opened_pages[selected_page.uid]
                 break
-        ##remove the check box link to the model name of this page (selected_page)
+        # remove the check box link to the model name of the selected_page
         try:
             self.sim_page.draw_page()
         except:
-            ## that page is already deleted no need to remove check box on
-            ##non existing page
+            # that page is already deleted no need to remove check box on
+            # non existing page
             pass
         try:
             self.batch_page.draw_page()
         except:
-            ## that page is already deleted no need to remove check box on
-            ##non existing page
+            # that page is already deleted no need to remove check box on
+            # non existing page
             pass
Index: src/sas/sasgui/perspectives/fitting/fitting.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitting.py	(revision ca4d9854c75a5344e770dec25221dfeb5a270915)
+++ src/sas/sasgui/perspectives/fitting/fitting.py	(revision 286c7571e8019b4c28a92d3d497cac7da825076c)
@@ -593,9 +593,11 @@
         : param datainfo: data
         """
-        #state = self.state_reader.get_state()
-        if state != None:
+        from pagestate import PageState
+        from simfitpage import SimFitPageState
+        if isinstance(state, PageState):
             state = state.clone()
-            # store fitting state in temp_state
             self.temp_state.append(state)
+        elif isinstance(state, SimFitPageState):
+            state.load_from_save_state(self)
         else:
             self.temp_state = []
@@ -1740,8 +1742,9 @@
                                       data_id=str(page_id) + " " + data.name + " unsmeared")
 
-                self.create_theory_1D(x, unsmeared_data, page_id, model, data, state,
-                                      data_description="Data unsmeared",
-                                      data_id="Data  " + data.name + " unsmeared",
-                                      dy=unsmeared_error)
+                if unsmeared_data is not None and unsmeared_error is not None:
+                    self.create_theory_1D(x, unsmeared_data, page_id, model, data, state,
+                                          data_description="Data unsmeared",
+                                          data_id="Data  " + data.name + " unsmeared",
+                                          dy=unsmeared_error)
                 
             if sq_model is not None and pq_model is not None:
